using System;
using System.Collections.Generic;
using System.Text;
using System.IO;



namespace TakeBackup
{
    class Program
    {

        const string executablename = "C:\\Program Files\\WinRAR\\WinRAR.exe";
        private static List<string> excludeFolders = new List<string>();

        static void Main(string[] args) {
            if (args.Length < 1) Console.WriteLine("usage: TakeBackup <dir name>");

            string foldername = "";

            if (Directory.Exists(args[0])) {
                foldername = args[0];
            }
            else if (File.Exists(args[0])) {
                foldername = Path.GetDirectoryName(args[0]);

                string[] options = File.ReadAllLines(args[0]);
                foreach (string var in options) {
                    if (var.StartsWith("ExcludeFolder: ")) {
                        string el = var.Substring("ExcludeFolder: ".Length);
                        string[] elarr = el.Split(' ');
                        excludeFolders.AddRange(elarr);
                    }
                }
            }

            //Try to find out the already existing backup files
            string backupfolder = Path.Combine(foldername, "bak");
            int backupnumber = 0;
            string destfile = "";
            if (Directory.Exists(backupfolder)) {
                string[] files = Directory.GetFiles(backupfolder, "*.zip");
                foreach (string sf in files) {
                    string t = sf.Substring(sf.Length - 7, 3);
                    int i = int.Parse(t);
                    if (i > backupnumber) backupnumber = i;
                }


            }
            else {
                Directory.CreateDirectory(backupfolder);
                backupnumber = 0;
            }
            backupnumber += 1;
            //Get the destfile name
            string[] solnfiles = Directory.GetFiles(foldername, "*.sln");
            string backupnameroot;
            if (solnfiles.Length > 0) {
                backupnameroot = Path.GetFileNameWithoutExtension(solnfiles[0]);
            }
            else {
                backupnameroot = Path.GetFileName(foldername);
                //backupnameroot = "backup";
            }

            string destfilename = backupnameroot;
            if (backupnumber < 10) destfilename += " 00" + backupnumber;
            else if (backupnumber < 100) destfilename += " 0" + backupnumber;
            else if (backupnumber < 1000) destfilename += " " + backupnumber;

            destfilename += ".zip";
            destfilename = Path.Combine(backupfolder, destfilename);
            
            //Get the file types to include.
            string cmdparams = "a -afzip \"" + destfilename + "\" ";
            string[] allFiles = Directory.GetFiles(foldername);
            foreach (string fn in allFiles) {
                if(FileShouldBeArchived(fn))
                    cmdparams += ("\""+Path.GetFileName(fn)+"\" ");
            }

            string[] allFolders = Directory.GetDirectories(foldername);
            foreach (string dn in allFolders) {
                if (FolderShouldBeArchived(dn))
                    cmdparams += ("\"" + Path.GetFileName(dn) + "\" ");
            }

            //string cmdparams = "a -afzip \"" + destfilename + "\" *.cs *.csproj *.sln *.ico *.resx bin Properties";
            System.Diagnostics.Process.Start(executablename, cmdparams);
            Console.WriteLine(executablename);
            Console.WriteLine(cmdparams);

        }

        public static string test(string a) {
            return Path.GetFileName(a);
        }


        private static bool FolderShouldBeArchived(string dn) {
            string rawname = Path.GetFileName(dn);
            switch (rawname) {
                case "obj": return false;
                case "bak": return false;
            }
            if (excludeFolders.Contains(rawname)) return false;
            return true;
        }

        private static bool FileShouldBeArchived(string fn) {
            //Dont archive suo files or Thumbs.db or .user  or .dobak files
            string ext = Path.GetExtension(fn);
            switch (ext) {
                case ".suo": return false;
                case ".user": return false;
                case ".dobak": return false;
                default:
                    break;
            }
            if (fn == "Thumbs.db") return false;
            return true;
        }




    }
}
